/*@@
   @file    StaticConformal_Functions.c
   @author  Automatically generated by CreateFunctionBindings.pl
   @desc
            The wrappers for functions provided by thorn StaticConformal.
   @enddesc
 @@*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cctk_Flesh.h"
#include "cctk_WarnLevel.h"



extern void StaticConf_ConfToPhysInPlace(const CCTK_INT nx ,
 const CCTK_INT ny ,
 const CCTK_INT nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz);
static void CCTK_Wrapper_CtoF_StaticConf_ConfToPhysInPlace(const CCTK_INT* nx ,
 const CCTK_INT* ny ,
 const CCTK_INT* nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz);
void CCTK_Wrapper_CtoF_StaticConf_ConfToPhysInPlace(const CCTK_INT* nx ,
 const CCTK_INT* ny ,
 const CCTK_INT* nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz)
{


  StaticConf_ConfToPhysInPlace(*nx , *ny , *nz , psi , gxx , gxy , gxz , gyy , gyz , gzz);
}


extern void StaticConf_PhysToConfInPlace(const CCTK_INT nx ,
 const CCTK_INT ny ,
 const CCTK_INT nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz);
static void CCTK_Wrapper_CtoF_StaticConf_PhysToConfInPlace(const CCTK_INT* nx ,
 const CCTK_INT* ny ,
 const CCTK_INT* nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz);
void CCTK_Wrapper_CtoF_StaticConf_PhysToConfInPlace(const CCTK_INT* nx ,
 const CCTK_INT* ny ,
 const CCTK_INT* nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz)
{


  StaticConf_PhysToConfInPlace(*nx , *ny , *nz , psi , gxx , gxy , gxz , gyy , gyz , gzz);
}

CCTK_INT Register_StaticConformal(void);
CCTK_INT AliasConfToPhysInPlace_C(void (*func)(const CCTK_INT nx ,
 const CCTK_INT ny ,
 const CCTK_INT nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz));
CCTK_INT AliasConfToPhysInPlace_F(void (*func)(const CCTK_INT* nx ,
 const CCTK_INT* ny ,
 const CCTK_INT* nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz));
CCTK_INT AliasPhysToConfInPlace_C(void (*func)(const CCTK_INT nx ,
 const CCTK_INT ny ,
 const CCTK_INT nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz));
CCTK_INT AliasPhysToConfInPlace_F(void (*func)(const CCTK_INT* nx ,
 const CCTK_INT* ny ,
 const CCTK_INT* nz ,
 const CCTK_REAL* psi ,
 CCTK_REAL* gxx ,
 CCTK_REAL* gxy ,
 CCTK_REAL* gxz ,
 CCTK_REAL* gyy ,
 CCTK_REAL* gyz ,
 CCTK_REAL* gzz));
CCTK_INT Register_StaticConformal(void)
{
  CCTK_INT ierr;

  ierr = 0;

  ierr += AliasConfToPhysInPlace_F(CCTK_Wrapper_CtoF_StaticConf_ConfToPhysInPlace);
  ierr += AliasConfToPhysInPlace_C(StaticConf_ConfToPhysInPlace);
  if (ierr)
  {
    CCTK_Warn(0, __LINE__, __FILE__, "Bindings",
              "Function already registered!");
  }
  ierr += AliasPhysToConfInPlace_F(CCTK_Wrapper_CtoF_StaticConf_PhysToConfInPlace);
  ierr += AliasPhysToConfInPlace_C(StaticConf_PhysToConfInPlace);
  if (ierr)
  {
    CCTK_Warn(0, __LINE__, __FILE__, "Bindings",
              "Function already registered!");
  }
  return ierr;
}
