/*@@
   @file       ScheduleStaticConformal.c
   @author     Automatically generated by CreateScheduleBindings.pl
   @desc
               Creates the schedule and parameter recovery bindings 
               for thorn StaticConformal
   @enddesc
@@*/


#ifdef SPEC 
#include "StaticConformal/cctk.h" 
#define THORN_DIR "StaticConformal" 
#else 
#include "StaticConformal/cctk.h"
#endif /* END SPEC */ 
#include "StaticConformal/CParameters.h"
#include "cctki_ScheduleBindings.h"
#include "StaticConformal/cctk_ScheduleFunctions.h"

/* Prototypes for Fortran schedule bindings functions to be registered */
/* Note that this is a cheat, we just need a function pointer. */


void CCTKi_BindingsSchedule_StaticConformal(void);
void CCTKi_BindingsSchedule_StaticConformal(void)
{
  DECLARE_CCTK_PARAMETERS
  if(!(1 >= 0 && 1  <= CCTK_MaxTimeLevels("StaticConformal::conformal_state")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %d timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 1, "StaticConformal::conformal_state", CCTK_MaxTimeLevels("StaticConformal::conformal_state"));
  CCTKi_ScheduleGroupStorage("StaticConformal::conformal_state",1);
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)StaticConformal_InitialiseState,
                           "StaticConformal_InitialiseState",
                           "StaticConformal",
                           "StaticConformal",
                           "Set the conformal_state variable to 0",
                           "CCTK_INITIAL",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of Options            */
                           1, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */,
                           "",
                           "ADMBase_InitialData");
  }
if(CCTK_Equals(metric_type,"static conformal"))
{
  if(CCTK_Equals(conformal_storage, "factor"))
  {
  if(!(1 >= 0 && 1  <= CCTK_MaxTimeLevels("StaticConformal::confac")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %d timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 1, "StaticConformal::confac", CCTK_MaxTimeLevels("StaticConformal::confac"));
  CCTKi_ScheduleGroupStorage("StaticConformal::confac",1);
  }
  if(CCTK_Equals(conformal_storage, "factor+derivs"))
  {
  if(!(1 >= 0 && 1  <= CCTK_MaxTimeLevels("StaticConformal::confac")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %d timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 1, "StaticConformal::confac", CCTK_MaxTimeLevels("StaticConformal::confac"));
  if(!(1 >= 0 && 1  <= CCTK_MaxTimeLevels("StaticConformal::confac_1derivs")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %d timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 1, "StaticConformal::confac_1derivs", CCTK_MaxTimeLevels("StaticConformal::confac_1derivs"));
  CCTKi_ScheduleGroupStorage("StaticConformal::confac",1);
  CCTKi_ScheduleGroupStorage("StaticConformal::confac_1derivs",1);
  }
  if(CCTK_Equals(conformal_storage, "factor+derivs+2nd derivs"))
  {
  if(!(1 >= 0 && 1  <= CCTK_MaxTimeLevels("StaticConformal::confac")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %d timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 1, "StaticConformal::confac", CCTK_MaxTimeLevels("StaticConformal::confac"));
  if(!(1 >= 0 && 1  <= CCTK_MaxTimeLevels("StaticConformal::confac_1derivs")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %d timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 1, "StaticConformal::confac_1derivs", CCTK_MaxTimeLevels("StaticConformal::confac_1derivs"));
  if(!(1 >= 0 && 1  <= CCTK_MaxTimeLevels("StaticConformal::confac_2derivs")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %d timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 1, "StaticConformal::confac_2derivs", CCTK_MaxTimeLevels("StaticConformal::confac_2derivs"));
  CCTKi_ScheduleGroupStorage("StaticConformal::confac",1);
  CCTKi_ScheduleGroupStorage("StaticConformal::confac_1derivs",1);
  CCTKi_ScheduleGroupStorage("StaticConformal::confac_2derivs",1);
  }
}
}

/*@@
  @routine    CCTKi_BindingsParameterRecovery_StaticConformal
  @author     Automatically generated by CreateScheduleBindings.pl
  @desc
              Creates the parameter recovery bindings for thorn StaticConformal
  @enddesc
@@*/

int CCTKi_BindingsParameterRecovery_StaticConformal(void);
int CCTKi_BindingsParameterRecovery_StaticConformal(void)
{
  /* this thorn doesn't define any parameter recovery routines */
  return (0);
}
