/*@@
   @file    ML_BSSN.c
   @author  Automatically generated by GridFuncStuff.pl
   @desc
            Creates the CCTK variables for thorn ML_BSSN
   @enddesc
 @@*/



#include <stddef.h>

#ifdef SPEC 
#include "ML_BSSN/cctk.h" 
#define THORN_DIR "ML_BSSN" 
#else 
#include "ML_BSSN/cctk.h"
#endif /* END SPEC */ 
#ifdef SPEC 
#include "ML_BSSN/cctk_Arguments.h" 
#else 
#include "ML_BSSN/cctk_Arguments.h"
#endif /* END SPEC */ 
#include "cctk_Parameter.h"
#include "cctk_WarnLevel.h"
#include "cctki_Groups.h"
#include "cctki_FortranWrappers.h"
#include "ML_BSSN/cctk_ScheduleFunctions.h"

int CactusBindingsVariables_ML_BSSN_Initialise(void);
static int CCTKi_BindingsFortranWrapperML_BSSN(void *_GH, void *fpointer);

static int CCTKi_BindingsFortranWrapperML_BSSN(void *_GH, void *fpointer)
{
  cGH const *const GH = _GH;
  const int _cctk_zero = 0;
  void (*function)(ML_BSSN_C2F_PROTO);
  DECLARE_ML_BSSN_C2F
  INITIALISE_ML_BSSN_C2F
  (void) (_cctk_zero + 0);

  function = (void (*) (ML_BSSN_C2F_PROTO)) fpointer;
  function (PASS_ML_BSSN_C2F (GH));

  return (0);
}

int CactusBindingsVariables_ML_BSSN_Initialise(void)
{
  const char * warn_mixeddim_gfs = "";
  int warn_mixeddim = 0;
  const CCTK_INT *allow_mixeddim_gfs;


  allow_mixeddim_gfs = CCTK_ParameterGet ("allow_mixeddim_gfs", "Cactus", 0);

  if (CCTKi_CreateGroup ("ML_LOG_CONFAC", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0.16666666666666666667",
                         NULL,
                         1,
                         "phi") == 1)
  {
    warn_mixeddim_gfs = "ML_log_confac";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_METRIC", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"DD_sym\" tensorweight=-0.66666666666666666667",
                         NULL,
                         6,
                         "gt11",
                         "gt12",
                         "gt13",
                         "gt22",
                         "gt23",
                         "gt33") == 1)
  {
    warn_mixeddim_gfs = "ML_metric";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_GAMMA", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" tensorweight=0.66666666666666666667",
                         NULL,
                         3,
                         "Xt1",
                         "Xt2",
                         "Xt3") == 1)
  {
    warn_mixeddim_gfs = "ML_Gamma";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_TRACE_CURV", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0",
                         NULL,
                         1,
                         "trK") == 1)
  {
    warn_mixeddim_gfs = "ML_trace_curv";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_CURV", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"DD_sym\" tensorweight=-0.66666666666666666667",
                         NULL,
                         6,
                         "At11",
                         "At12",
                         "At13",
                         "At22",
                         "At23",
                         "At33") == 1)
  {
    warn_mixeddim_gfs = "ML_curv";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_LAPSE", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0",
                         NULL,
                         1,
                         "alpha") == 1)
  {
    warn_mixeddim_gfs = "ML_lapse";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_DTLAPSE", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0",
                         NULL,
                         1,
                         "A") == 1)
  {
    warn_mixeddim_gfs = "ML_dtlapse";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_SHIFT", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" tensorweight=0",
                         NULL,
                         3,
                         "beta1",
                         "beta2",
                         "beta3") == 1)
  {
    warn_mixeddim_gfs = "ML_shift";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_DTSHIFT", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" tensorweight=0",
                         NULL,
                         3,
                         "B1",
                         "B2",
                         "B3") == 1)
  {
    warn_mixeddim_gfs = "ML_dtshift";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_HAM", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0",
                         NULL,
                         1,
                         "H") == 1)
  {
    warn_mixeddim_gfs = "ML_Ham";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_MOM", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"D\" tensorweight=0",
                         NULL,
                         3,
                         "M1",
                         "M2",
                         "M3") == 1)
  {
    warn_mixeddim_gfs = "ML_mom";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_CONS_DETG", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=2",
                         NULL,
                         1,
                         "cS") == 1)
  {
    warn_mixeddim_gfs = "ML_cons_detg";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_CONS_GAMMA", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" tensorweight=0.66666666666666666667",
                         NULL,
                         3,
                         "cXt1",
                         "cXt2",
                         "cXt3") == 1)
  {
    warn_mixeddim_gfs = "ML_cons_Gamma";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_CONS_TRACEA", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0",
                         NULL,
                         1,
                         "cA") == 1)
  {
    warn_mixeddim_gfs = "ML_cons_traceA";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_CURVRHS", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"DD_sym\" tensorweight=-0.66666666666666666667 Prolongation=\"None\"",
                         NULL,
                         6,
                         "At11rhs",
                         "At12rhs",
                         "At13rhs",
                         "At22rhs",
                         "At23rhs",
                         "At33rhs") == 1)
  {
    warn_mixeddim_gfs = "ML_curvrhs";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_DTLAPSERHS", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0 Prolongation=\"None\"",
                         NULL,
                         1,
                         "Arhs") == 1)
  {
    warn_mixeddim_gfs = "ML_dtlapserhs";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_DTSHIFTRHS", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" tensorweight=0 Prolongation=\"None\"",
                         NULL,
                         3,
                         "B1rhs",
                         "B2rhs",
                         "B3rhs") == 1)
  {
    warn_mixeddim_gfs = "ML_dtshiftrhs";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_GAMMARHS", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" tensorweight=0.66666666666666666667 Prolongation=\"None\"",
                         NULL,
                         3,
                         "Xt1rhs",
                         "Xt2rhs",
                         "Xt3rhs") == 1)
  {
    warn_mixeddim_gfs = "ML_Gammarhs";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_LAPSERHS", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0 Prolongation=\"None\"",
                         NULL,
                         1,
                         "alpharhs") == 1)
  {
    warn_mixeddim_gfs = "ML_lapserhs";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_LOG_CONFACRHS", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0.16666666666666666667 Prolongation=\"None\"",
                         NULL,
                         1,
                         "phirhs") == 1)
  {
    warn_mixeddim_gfs = "ML_log_confacrhs";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_METRICRHS", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"DD_sym\" tensorweight=-0.66666666666666666667 Prolongation=\"None\"",
                         NULL,
                         6,
                         "gt11rhs",
                         "gt12rhs",
                         "gt13rhs",
                         "gt22rhs",
                         "gt23rhs",
                         "gt33rhs") == 1)
  {
    warn_mixeddim_gfs = "ML_metricrhs";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_SHIFTRHS", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" tensorweight=0 Prolongation=\"None\"",
                         NULL,
                         3,
                         "beta1rhs",
                         "beta2rhs",
                         "beta3rhs") == 1)
  {
    warn_mixeddim_gfs = "ML_shiftrhs";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("ML_TRACE_CURVRHS", "ML_BSSN", "ML_BSSN",
                         "GF", "REAL", "PUBLIC",
                         3, 3,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0 Prolongation=\"None\"",
                         NULL,
                         1,
                         "trKrhs") == 1)
  {
    warn_mixeddim_gfs = "ML_trace_curvrhs";
    warn_mixeddim = 3;
  }

  if (*warn_mixeddim_gfs)
  {
    if (allow_mixeddim_gfs && *allow_mixeddim_gfs)
    {
      CCTK_VWarn (2, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "creating GF group '%s' with different dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
    else
    {
      CCTK_VWarn (0, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "cannot create GF group '%s' with dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
 }

  CCTKi_RegisterFortranWrapper("ML_BSSN", CCTKi_BindingsFortranWrapperML_BSSN);

  return 0;
}
