/*@@
   @file    StaticConformal.c
   @author  Automatically generated by GridFuncStuff.pl
   @desc
            Creates the CCTK variables for thorn StaticConformal
   @enddesc
 @@*/



#include <stddef.h>

#ifdef SPEC 
#include "StaticConformal/cctk.h" 
#define THORN_DIR "StaticConformal" 
#else 
#include "StaticConformal/cctk.h"
#endif /* END SPEC */ 
#ifdef SPEC 
#include "StaticConformal/cctk_Arguments.h" 
#else 
#include "StaticConformal/cctk_Arguments.h"
#endif /* END SPEC */ 
#include "cctk_Parameter.h"
#include "cctk_WarnLevel.h"
#include "cctki_Groups.h"
#include "cctki_FortranWrappers.h"
#include "StaticConformal/cctk_ScheduleFunctions.h"

int CactusBindingsVariables_StaticConformal_Initialise(void);
static int CCTKi_BindingsFortranWrapperStaticConformal(void *_GH, void *fpointer);

static int CCTKi_BindingsFortranWrapperStaticConformal(void *_GH, void *fpointer)
{
  cGH const *const GH = _GH;
  const int _cctk_zero = 0;
  void (*function)(STATICCONFORMAL_C2F_PROTO);
  DECLARE_STATICCONFORMAL_C2F
  INITIALISE_STATICCONFORMAL_C2F
  (void) (_cctk_zero + 0);

  function = (void (*) (STATICCONFORMAL_C2F_PROTO)) fpointer;
  function (PASS_STATICCONFORMAL_C2F (GH));

  return (0);
}

int CactusBindingsVariables_StaticConformal_Initialise(void)
{
  const char * warn_mixeddim_gfs = "";
  int warn_mixeddim = 0;
  const CCTK_INT *allow_mixeddim_gfs;


  allow_mixeddim_gfs = CCTK_ParameterGet ("allow_mixeddim_gfs", "Cactus", 0);

  if (CCTKi_CreateGroup ("CONFORMAL_STATE", "STATICCONFORMAL", "STATICCONFORMAL",
                         "SCALAR", "INT", "PUBLIC",
                         0, 1,
                         "CONSTANT",
                         "", "",
                         "",
                         NULL,
                         1,
                         "conformal_state") == 1)
  {
    warn_mixeddim_gfs = "conformal_state";
    warn_mixeddim = 0;
  }
  if (CCTKi_CreateGroup ("CONFAC", "STATICCONFORMAL", "STATICCONFORMAL",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" Prolongation=\"None\" InterpNumTimelevels=1",
                         NULL,
                         1,
                         "psi") == 1)
  {
    warn_mixeddim_gfs = "confac";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("CONFAC_1DERIVS", "STATICCONFORMAL", "STATICCONFORMAL",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" Prolongation=\"None\" InterpNumTimelevels=1",
                         NULL,
                         3,
                         "psix",
                         "psiy",
                         "psiz") == 1)
  {
    warn_mixeddim_gfs = "confac_1derivs";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("CONFAC_2DERIVS", "STATICCONFORMAL", "STATICCONFORMAL",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"dd_sym\" Prolongation=\"None\" InterpNumTimelevels=1",
                         NULL,
                         6,
                         "psixx",
                         "psixy",
                         "psixz",
                         "psiyy",
                         "psiyz",
                         "psizz") == 1)
  {
    warn_mixeddim_gfs = "confac_2derivs";
    warn_mixeddim = 3;
  }

  if (*warn_mixeddim_gfs)
  {
    if (allow_mixeddim_gfs && *allow_mixeddim_gfs)
    {
      CCTK_VWarn (2, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "creating GF group '%s' with different dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
    else
    {
      CCTK_VWarn (0, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "cannot create GF group '%s' with dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
 }

  CCTKi_RegisterFortranWrapper("StaticConformal", CCTKi_BindingsFortranWrapperStaticConformal);

  return 0;
}
