/*@@
   @header  CartGrid3D_Prototypes.h
   @author  Automatically generated by CreateFunctionBindings.pl
   @desc
            Prototypes for overloaded functions used by this thorn
   @enddesc
  @@*/


#ifndef _CARTGRID3D_PROTOTYPES_H_
#define _CARTGRID3D_PROTOTYPES_H_  1

#ifdef CCODE
#ifdef __cplusplus
extern "C" {
#endif

CCTK_INT Boundary_SelectedGVs(const CCTK_POINTER_TO_CONST GH ,
 const CCTK_INT array_size ,
 CCTK_INT* var_indicies ,
 CCTK_INT* faces ,
 CCTK_INT* boundary_widths ,
 CCTK_INT* table_handles ,
 CCTK_STRING bc_name);

CCTK_INT ConvertFromPhysicalBoundary(const CCTK_INT size ,
 const CCTK_REAL* physical_min ,
 const CCTK_REAL* physical_max ,
 CCTK_REAL* interior_min ,
 CCTK_REAL* interior_max ,
 CCTK_REAL* exterior_min ,
 CCTK_REAL* exterior_max ,
 const CCTK_REAL* spacing);

CCTK_INT GetDomainSpecification(const CCTK_INT size ,
 CCTK_REAL* physical_min ,
 CCTK_REAL* physical_max ,
 CCTK_REAL* interior_min ,
 CCTK_REAL* interior_max ,
 CCTK_REAL* exterior_min ,
 CCTK_REAL* exterior_max ,
 CCTK_REAL* spacing);

CCTK_INT MultiPatch_ConvertFromPhysicalBoundary(const CCTK_INT map ,
 const CCTK_INT size ,
 const CCTK_REAL* physical_min ,
 const CCTK_REAL* physical_max ,
 CCTK_REAL* interior_min ,
 CCTK_REAL* interior_max ,
 CCTK_REAL* exterior_min ,
 CCTK_REAL* exterior_max ,
 const CCTK_REAL* spacing);

CCTK_INT MultiPatch_GetDomainSpecification(const CCTK_INT map ,
 const CCTK_INT size ,
 CCTK_REAL* physical_min ,
 CCTK_REAL* physical_max ,
 CCTK_REAL* interior_min ,
 CCTK_REAL* interior_max ,
 CCTK_REAL* exterior_min ,
 CCTK_REAL* exterior_max ,
 CCTK_REAL* spacing);

CCTK_INT MultiPatch_GetMap(const CCTK_POINTER_TO_CONST cctkGH);

CCTK_INT SymmetryRegister(CCTK_STRING sym_name);

CCTK_INT SymmetryRegisterGrid(const CCTK_POINTER cctkGH ,
 const CCTK_INT sym_handle ,
 const CCTK_INT* which_faces ,
 const CCTK_INT* symmetry_zone_width);

#ifdef __cplusplus
}
#endif
#endif /* CCODE */

#ifdef FCODE
#ifdef F90CODE
#define DECLARE_CARTGRID3D_FUNCTIONS _DECLARE_CCTK_FUNCTIONS \
  interface &&\
     CCTK_INT function Boundary_SelectedGVs (GH, array_size, var_indicies, faces, boundary_widths, table_handles, bc_name) &&\
       implicit none &&\
       CCTK_POINTER_TO_CONST GH &&\
       CCTK_INT array_size &&\
       CCTK_INT var_indicies(*) &&\
       CCTK_INT faces(*) &&\
       CCTK_INT boundary_widths(*) &&\
       CCTK_INT table_handles(*) &&\
       character(*) bc_name &&\
     end function Boundary_SelectedGVs &&\
  end interface &&\
  interface &&\
     CCTK_INT function ConvertFromPhysicalBoundary (size, physical_min, physical_max, interior_min, interior_max, exterior_min, exterior_max, spacing) &&\
       implicit none &&\
       CCTK_INT size &&\
       CCTK_REAL physical_min(*) &&\
       CCTK_REAL physical_max(*) &&\
       CCTK_REAL interior_min(*) &&\
       CCTK_REAL interior_max(*) &&\
       CCTK_REAL exterior_min(*) &&\
       CCTK_REAL exterior_max(*) &&\
       CCTK_REAL spacing(*) &&\
     end function ConvertFromPhysicalBoundary &&\
  end interface &&\
  interface &&\
     CCTK_INT function GetDomainSpecification (size, physical_min, physical_max, interior_min, interior_max, exterior_min, exterior_max, spacing) &&\
       implicit none &&\
       CCTK_INT size &&\
       CCTK_REAL physical_min(*) &&\
       CCTK_REAL physical_max(*) &&\
       CCTK_REAL interior_min(*) &&\
       CCTK_REAL interior_max(*) &&\
       CCTK_REAL exterior_min(*) &&\
       CCTK_REAL exterior_max(*) &&\
       CCTK_REAL spacing(*) &&\
     end function GetDomainSpecification &&\
  end interface &&\
  interface &&\
     CCTK_INT function MultiPatch_ConvertFromPhysicalBoundary (map, size, physical_min, physical_max, interior_min, interior_max, exterior_min, exterior_max, spacing) &&\
       implicit none &&\
       CCTK_INT map &&\
       CCTK_INT size &&\
       CCTK_REAL physical_min(*) &&\
       CCTK_REAL physical_max(*) &&\
       CCTK_REAL interior_min(*) &&\
       CCTK_REAL interior_max(*) &&\
       CCTK_REAL exterior_min(*) &&\
       CCTK_REAL exterior_max(*) &&\
       CCTK_REAL spacing(*) &&\
     end function MultiPatch_ConvertFromPhysicalBoundary &&\
  end interface &&\
  interface &&\
     CCTK_INT function MultiPatch_GetDomainSpecification (map, size, physical_min, physical_max, interior_min, interior_max, exterior_min, exterior_max, spacing) &&\
       implicit none &&\
       CCTK_INT map &&\
       CCTK_INT size &&\
       CCTK_REAL physical_min(*) &&\
       CCTK_REAL physical_max(*) &&\
       CCTK_REAL interior_min(*) &&\
       CCTK_REAL interior_max(*) &&\
       CCTK_REAL exterior_min(*) &&\
       CCTK_REAL exterior_max(*) &&\
       CCTK_REAL spacing(*) &&\
     end function MultiPatch_GetDomainSpecification &&\
  end interface &&\
  interface &&\
     CCTK_INT function MultiPatch_GetMap (cctkGH) &&\
       implicit none &&\
       CCTK_POINTER_TO_CONST cctkGH &&\
     end function MultiPatch_GetMap &&\
  end interface &&\
  interface &&\
     CCTK_INT function SymmetryRegister (sym_name) &&\
       implicit none &&\
       character(*) sym_name &&\
     end function SymmetryRegister &&\
  end interface &&\
  interface &&\
     CCTK_INT function SymmetryRegisterGrid (cctkGH, sym_handle, which_faces, symmetry_zone_width) &&\
       implicit none &&\
       CCTK_POINTER cctkGH &&\
       CCTK_INT sym_handle &&\
       CCTK_INT which_faces(*) &&\
       CCTK_INT symmetry_zone_width(*) &&\
     end function SymmetryRegisterGrid &&\
  end interface &&\

#else /* ! F90CODE */

#define DECLARE_CARTGRID3D_FUNCTIONS _DECLARE_CCTK_FUNCTIONS \
  external Boundary_SelectedGVs &&\
  CCTK_INT Boundary_SelectedGVs &&\
  external ConvertFromPhysicalBoundary &&\
  CCTK_INT ConvertFromPhysicalBoundary &&\
  external GetDomainSpecification &&\
  CCTK_INT GetDomainSpecification &&\
  external MultiPatch_ConvertFromPhysicalBoundary &&\
  CCTK_INT MultiPatch_ConvertFromPhysicalBoundary &&\
  external MultiPatch_GetDomainSpecification &&\
  CCTK_INT MultiPatch_GetDomainSpecification &&\
  external MultiPatch_GetMap &&\
  CCTK_INT MultiPatch_GetMap &&\
  external SymmetryRegister &&\
  CCTK_INT SymmetryRegister &&\
  external SymmetryRegisterGrid &&\
  CCTK_INT SymmetryRegisterGrid &&\

#endif /* ! F90CODE */
#endif /* FCODE */

#endif

